org.keycloak.models

## Interface RealmModel

- All Superinterfaces:
    RoleContainerModel
  All Known Subinterfaces:
    CachedRealmModel
  All Known Implementing Classes:
    RealmAdapter, RealmAdapter

      public interface RealmModel
      extends RoleContainerModel

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `RealmModel.IdentityProviderRemovedEvent`
    `static interface` | `RealmModel.IdentityProviderUpdatedEvent`
    `static interface` | `RealmModel.RealmCreationEvent`
    `static interface` | `RealmModel.RealmPostCreateEvent`
    `static interface` | `RealmModel.RealmRemovedEvent`

    - ### Nested classes/interfaces inherited from interface org.keycloak.models.RoleContainerModel

      `RoleContainerModel.RoleRemovedEvent`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `AuthenticationFlowModel` | `addAuthenticationFlow(AuthenticationFlowModel model)`
    `AuthenticatorConfigModel` | `addAuthenticatorConfig(AuthenticatorConfigModel model)`
    `AuthenticationExecutionModel` | `addAuthenticatorExecution(AuthenticationExecutionModel model)`
    `ClientModel` | `addClient(String name)`
    `ClientModel` | `addClient(String id, String clientId)`
    `ClientScopeModel` | `addClientScope(String name)`
    `ClientScopeModel` | `addClientScope(String id, String name)`
    `ComponentModel` | `addComponentModel(ComponentModel model)` Adds component model.
    `void` | `addDefaultClientScope(ClientScopeModel clientScope, boolean defaultScope)`
    `void` | `addDefaultGroup(GroupModel group)`
    `void` | `addIdentityProvider(IdentityProviderModel identityProvider)`
    `IdentityProviderMapperModel` | `addIdentityProviderMapper(IdentityProviderMapperModel model)`
    `RequiredActionProviderModel` | `addRequiredActionProvider(RequiredActionProviderModel model)`
    `void` | `addRequiredCredential(String cred)`
    `default GroupModel` | `createGroup(String name)`
    `default GroupModel` | `createGroup(String name, GroupModel toParent)`
    `default GroupModel` | `createGroup(String id, String name)`
    `GroupModel` | `createGroup(String id, String name, GroupModel toParent)`
    `int` | `getAccessCodeLifespan()`
    `int` | `getAccessCodeLifespanLogin()`
    `int` | `getAccessCodeLifespanUserAction()`
    `int` | `getAccessTokenLifespan()`
    `int` | `getAccessTokenLifespanForImplicitFlow()`
    `String` | `getAccountTheme()`
    `int` | `getActionTokenGeneratedByAdminLifespan()`
    `int` | `getActionTokenGeneratedByUserLifespan()`
    `int` | `getActionTokenGeneratedByUserLifespan(String actionTokenType)`
    `String` | `getAdminTheme()`
    `default List<ClientModel>` | `getAlwaysDisplayInConsoleClients()` Deprecated.
    `Stream<ClientModel>` | `getAlwaysDisplayInConsoleClientsStream()`
    `String` | `getAttribute(String name)`
    `Boolean` | `getAttribute(String name, Boolean defaultValue)`
    `Integer` | `getAttribute(String name, Integer defaultValue)`
    `Long` | `getAttribute(String name, Long defaultValue)`
    `Map<String,String>` | `getAttributes()`
    `AuthenticationExecutionModel` | `getAuthenticationExecutionByFlowId(String flowId)`
    `AuthenticationExecutionModel` | `getAuthenticationExecutionById(String id)`
    `default List<AuthenticationExecutionModel>` | `getAuthenticationExecutions(String flowId)` Deprecated. Use `getAuthenticationExecutionsStream` instead.
    `Stream<AuthenticationExecutionModel>` | `getAuthenticationExecutionsStream(String flowId)` Returns sorted `AuthenticationExecutionModel` as a stream.
    `AuthenticationFlowModel` | `getAuthenticationFlowById(String id)`
    `default List<AuthenticationFlowModel>` | `getAuthenticationFlows()` Deprecated. Use `getAuthenticationFlowsStream` instead.
    `Stream<AuthenticationFlowModel>` | `getAuthenticationFlowsStream()`
    `AuthenticatorConfigModel` | `getAuthenticatorConfigByAlias(String alias)`
    `AuthenticatorConfigModel` | `getAuthenticatorConfigById(String id)`
    `default List<AuthenticatorConfigModel>` | `getAuthenticatorConfigs()` Deprecated. Use `getAuthenticatorConfigsStream` instead.
    `Stream<AuthenticatorConfigModel>` | `getAuthenticatorConfigsStream()`
    `AuthenticationFlowModel` | `getBrowserFlow()`
    `Map<String,String>` | `getBrowserSecurityHeaders()`
    `AuthenticationFlowModel` | `getClientAuthenticationFlow()`
    `ClientModel` | `getClientByClientId(String clientId)`
    `ClientModel` | `getClientById(String id)`
    `int` | `getClientOfflineSessionIdleTimeout()`
    `int` | `getClientOfflineSessionMaxLifespan()`
    `default List<ClientModel>` | `getClients()` Deprecated.
    `default List<ClientModel>` | `getClients(Integer firstResult, Integer maxResults)` Deprecated.
    `ClientScopeModel` | `getClientScopeById(String id)`
    `default List<ClientScopeModel>` | `getClientScopes()` Deprecated. Use `getClientScopesStream` instead.
    `Stream<ClientScopeModel>` | `getClientScopesStream()`
    `Long` | `getClientsCount()`
    `int` | `getClientSessionIdleTimeout()`
    `int` | `getClientSessionMaxLifespan()`
    `Stream<ClientModel>` | `getClientsStream()`
    `Stream<ClientModel>` | `getClientsStream(Integer firstResult, Integer maxResults)`
    `default List<ClientStorageProviderModel>` | `getClientStorageProviders()` Deprecated. Use `getClientStorageProvidersStream` instead.
    `default Stream<ClientStorageProviderModel>` | `getClientStorageProvidersStream()` Returns sorted `ClientStorageProviderModel` as a stream.
    `ComponentModel` | `getComponent(String id)`
    `default List<ComponentModel>` | `getComponents()` Deprecated. Use `getComponentsStream` instead.
    `default List<ComponentModel>` | `getComponents(String parentId)` Deprecated. Use `getComponentsStream` instead.
    `default List<ComponentModel>` | `getComponents(String parentId, String providerType)` Deprecated. Use `getComponentsStream` instead.
    `Stream<ComponentModel>` | `getComponentsStream()`
    `Stream<ComponentModel>` | `getComponentsStream(String parentId)`
    `Stream<ComponentModel>` | `getComponentsStream(String parentId, String providerType)` Returns stream of ComponentModels for specific parentId and providerType.
    `default List<ClientScopeModel>` | `getDefaultClientScopes(boolean defaultScope)` Deprecated. Use `getDefaultClientScopesStream` instead.
    `Stream<ClientScopeModel>` | `getDefaultClientScopesStream(boolean defaultScope)`
    `default List<GroupModel>` | `getDefaultGroups()` Deprecated.
    `Stream<GroupModel>` | `getDefaultGroupsStream()`
    `String` | `getDefaultLocale()`
    `String` | `getDefaultSignatureAlgorithm()`
    `AuthenticationFlowModel` | `getDirectGrantFlow()`
    `String` | `getDisplayName()`
    `String` | `getDisplayNameHtml()`
    `AuthenticationFlowModel` | `getDockerAuthenticationFlow()`
    `String` | `getEmailTheme()`
    `default Set<String>` | `getEnabledEventTypes()` Deprecated. Use `getEnabledEventTypesStream` instead.
    `Stream<String>` | `getEnabledEventTypesStream()`
    `long` | `getEventsExpiration()`
    `default Set<String>` | `getEventsListeners()` Deprecated. Use `getEventsListenersStream` instead.
    `Stream<String>` | `getEventsListenersStream()`
    `int` | `getFailureFactor()`
    `AuthenticationFlowModel` | `getFlowByAlias(String alias)`
    `GroupModel` | `getGroupById(String id)`
    `default List<GroupModel>` | `getGroups()` Deprecated. Use `getGroupsStream` instead.
    `Long` | `getGroupsCount(Boolean onlyTopGroups)`
    `Long` | `getGroupsCountByNameContaining(String search)`
    `Stream<GroupModel>` | `getGroupsStream()`
    `String` | `getId()`
    `IdentityProviderModel` | `getIdentityProviderByAlias(String alias)`
    `IdentityProviderMapperModel` | `getIdentityProviderMapperById(String id)`
    `IdentityProviderMapperModel` | `getIdentityProviderMapperByName(String brokerAlias, String name)`
    `default Set<IdentityProviderMapperModel>` | `getIdentityProviderMappers()` Deprecated. Use `getIdentityProviderMappersStream` instead.
    `default Set<IdentityProviderMapperModel>` | `getIdentityProviderMappersByAlias(String brokerAlias)` Deprecated. Use `getIdentityProviderMappersByAliasStream` instead.
    `Stream<IdentityProviderMapperModel>` | `getIdentityProviderMappersByAliasStream(String brokerAlias)`
    `Stream<IdentityProviderMapperModel>` | `getIdentityProviderMappersStream()`
    `default List<IdentityProviderModel>` | `getIdentityProviders()` Deprecated. Use `getIdentityProvidersStream` instead.
    `Stream<IdentityProviderModel>` | `getIdentityProvidersStream()`
    `String` | `getLoginTheme()`
    `ClientModel` | `getMasterAdminClient()`
    `int` | `getMaxDeltaTimeSeconds()`
    `int` | `getMaxFailureWaitSeconds()`
    `int` | `getMinimumQuickLoginWaitSeconds()`
    `String` | `getName()`
    `int` | `getNotBefore()` Time in seconds since epoc
    `int` | `getOfflineSessionIdleTimeout()`
    `int` | `getOfflineSessionMaxLifespan()`
    `OTPPolicy` | `getOTPPolicy()`
    `PasswordPolicy` | `getPasswordPolicy()`
    `long` | `getQuickLoginCheckMilliSeconds()`
    `Map<String,Map<String,String>>` | `getRealmLocalizationTexts()`
    `Map<String,String>` | `getRealmLocalizationTextsByLocale(String locale)`
    `int` | `getRefreshTokenMaxReuse()`
    `AuthenticationFlowModel` | `getRegistrationFlow()`
    `RequiredActionProviderModel` | `getRequiredActionProviderByAlias(String alias)`
    `RequiredActionProviderModel` | `getRequiredActionProviderById(String id)`
    `default List<RequiredActionProviderModel>` | `getRequiredActionProviders()` Deprecated. Use `getRequiredActionProvidersStream` instead.
    `Stream<RequiredActionProviderModel>` | `getRequiredActionProvidersStream()` Returns sorted `RequiredActionProviderModel` as a stream.
    `default List<RequiredCredentialModel>` | `getRequiredCredentials()` Deprecated. Use `getRequiredCredentialsStream` instead.
    `Stream<RequiredCredentialModel>` | `getRequiredCredentialsStream()`
    `AuthenticationFlowModel` | `getResetCredentialsFlow()`
    `RoleModel` | `getRoleById(String id)`
    `default List<RoleStorageProviderModel>` | `getRoleStorageProviders()` Deprecated. Use `getRoleStorageProvidersStream` instead.
    `default Stream<RoleStorageProviderModel>` | `getRoleStorageProvidersStream()` Returns sorted `RoleStorageProviderModel` as a stream.
    `Map<String,String>` | `getSmtpConfig()`
    `SslRequired` | `getSslRequired()`
    `int` | `getSsoSessionIdleTimeout()`
    `int` | `getSsoSessionIdleTimeoutRememberMe()`
    `int` | `getSsoSessionMaxLifespan()`
    `int` | `getSsoSessionMaxLifespanRememberMe()`
    `default Stream<ComponentModel>` | `getStorageProviders(Class<? extends Provider> storageProviderClass)` Returns stream of ComponentModels that represent StorageProviders for class storageProviderClass in this realm
    `default Set<String>` | `getSupportedLocales()` Deprecated. Use `getSupportedLocalesStream` instead.
    `Stream<String>` | `getSupportedLocalesStream()`
    `default List<GroupModel>` | `getTopLevelGroups()` Deprecated. Use `getTopLevelGroups` instead.
    `default List<GroupModel>` | `getTopLevelGroups(Integer first, Integer max)` Deprecated. Use `getTopLevelGroupsStream` instead.
    `Stream<GroupModel>` | `getTopLevelGroupsStream()`
    `Stream<GroupModel>` | `getTopLevelGroupsStream(Integer first, Integer max)`
    `Map<String,Integer>` | `getUserActionTokenLifespans()` This method will return a map with all the lifespans available or an empty map, but never null.
    `default List<UserStorageProviderModel>` | `getUserStorageProviders()` Deprecated. Use `getUserStorageProvidersStream` instead.
    `default Stream<UserStorageProviderModel>` | `getUserStorageProvidersStream()` Returns sorted `UserStorageProviderModel` as a stream.
    `int` | `getWaitIncrementSeconds()`
    `WebAuthnPolicy` | `getWebAuthnPolicy()`
    `WebAuthnPolicy` | `getWebAuthnPolicyPasswordless()`
    `ComponentModel` | `importComponentModel(ComponentModel model)` Adds component model.
    `boolean` | `isAdminEventsDetailsEnabled()`
    `boolean` | `isAdminEventsEnabled()`
    `boolean` | `isBruteForceProtected()`
    `boolean` | `isDuplicateEmailsAllowed()`
    `boolean` | `isEditUsernameAllowed()`
    `boolean` | `isEnabled()`
    `boolean` | `isEventsEnabled()`
    `boolean` | `isIdentityFederationEnabled()`
    `boolean` | `isInternationalizationEnabled()`
    `boolean` | `isLoginWithEmailAllowed()`
    `boolean` | `isOfflineSessionMaxLifespanEnabled()`
    `boolean` | `isPermanentLockout()`
    `boolean` | `isRegistrationAllowed()`
    `boolean` | `isRegistrationEmailAsUsername()`
    `boolean` | `isRememberMe()`
    `boolean` | `isResetPasswordAllowed()`
    `boolean` | `isRevokeRefreshToken()`
    `boolean` | `isUserManagedAccessAllowed()`
    `boolean` | `isVerifyEmail()`
    `void` | `moveGroup(GroupModel group, GroupModel toParent)`
    `void` | `patchRealmLocalizationTexts(String locale, Map<String,String> localizationTexts)` Patches the realm-specific localization texts.
    `void` | `removeAttribute(String name)`
    `void` | `removeAuthenticationFlow(AuthenticationFlowModel model)`
    `void` | `removeAuthenticatorConfig(AuthenticatorConfigModel model)`
    `void` | `removeAuthenticatorExecution(AuthenticationExecutionModel model)`
    `boolean` | `removeClient(String id)`
    `boolean` | `removeClientScope(String id)`
    `void` | `removeComponent(ComponentModel component)`
    `void` | `removeComponents(String parentId)`
    `void` | `removeDefaultClientScope(ClientScopeModel clientScope)`
    `void` | `removeDefaultGroup(GroupModel group)`
    `boolean` | `removeGroup(GroupModel group)`
    `void` | `removeIdentityProviderByAlias(String alias)`
    `void` | `removeIdentityProviderMapper(IdentityProviderMapperModel mapping)`
    `boolean` | `removeRealmLocalizationTexts(String locale)`
    `void` | `removeRequiredActionProvider(RequiredActionProviderModel model)`
    `default List<ClientModel>` | `searchClientByClientId(String clientId, Integer firstResult, Integer maxResults)` Deprecated.
    `Stream<ClientModel>` | `searchClientByClientIdStream(String clientId, Integer firstResult, Integer maxResults)`
    `default List<GroupModel>` | `searchForGroupByName(String search, Integer first, Integer max)` Deprecated. Use `searchForGroupByName` instead.
    `Stream<GroupModel>` | `searchForGroupByNameStream(String search, Integer first, Integer max)`
    `void` | `setAccessCodeLifespan(int seconds)`
    `void` | `setAccessCodeLifespanLogin(int seconds)`
    `void` | `setAccessCodeLifespanUserAction(int seconds)`
    `void` | `setAccessTokenLifespan(int seconds)`
    `void` | `setAccessTokenLifespanForImplicitFlow(int seconds)`
    `void` | `setAccountTheme(String name)`
    `void` | `setActionTokenGeneratedByAdminLifespan(int seconds)`
    `void` | `setActionTokenGeneratedByUserLifespan(int seconds)`
    `void` | `setActionTokenGeneratedByUserLifespan(String actionTokenType, Integer seconds)`
    `void` | `setAdminEventsDetailsEnabled(boolean enabled)`
    `void` | `setAdminEventsEnabled(boolean enabled)`
    `void` | `setAdminTheme(String name)`
    `void` | `setAttribute(String name, Boolean value)`
    `void` | `setAttribute(String name, Integer value)`
    `void` | `setAttribute(String name, Long value)`
    `void` | `setAttribute(String name, String value)`
    `void` | `setBrowserFlow(AuthenticationFlowModel flow)`
    `void` | `setBrowserSecurityHeaders(Map<String,String> headers)`
    `void` | `setBruteForceProtected(boolean value)`
    `void` | `setClientAuthenticationFlow(AuthenticationFlowModel flow)`
    `void` | `setClientOfflineSessionIdleTimeout(int seconds)`
    `void` | `setClientOfflineSessionMaxLifespan(int seconds)`
    `void` | `setClientSessionIdleTimeout(int seconds)`
    `void` | `setClientSessionMaxLifespan(int seconds)`
    `void` | `setDefaultLocale(String locale)`
    `void` | `setDefaultSignatureAlgorithm(String defaultSignatureAlgorithm)`
    `void` | `setDirectGrantFlow(AuthenticationFlowModel flow)`
    `void` | `setDisplayName(String displayName)`
    `void` | `setDisplayNameHtml(String displayNameHtml)`
    `void` | `setDockerAuthenticationFlow(AuthenticationFlowModel flow)`
    `void` | `setDuplicateEmailsAllowed(boolean duplicateEmailsAllowed)`
    `void` | `setEditUsernameAllowed(boolean editUsernameAllowed)`
    `void` | `setEmailTheme(String name)`
    `void` | `setEnabled(boolean enabled)`
    `void` | `setEnabledEventTypes(Set<String> enabledEventTypes)`
    `void` | `setEventsEnabled(boolean enabled)`
    `void` | `setEventsExpiration(long expiration)`
    `void` | `setEventsListeners(Set<String> listeners)`
    `void` | `setFailureFactor(int failureFactor)`
    `void` | `setInternationalizationEnabled(boolean enabled)`
    `void` | `setLoginTheme(String name)`
    `void` | `setLoginWithEmailAllowed(boolean loginWithEmailAllowed)`
    `void` | `setMasterAdminClient(ClientModel client)`
    `void` | `setMaxDeltaTimeSeconds(int val)`
    `void` | `setMaxFailureWaitSeconds(int val)`
    `void` | `setMinimumQuickLoginWaitSeconds(int val)`
    `void` | `setName(String name)`
    `void` | `setNotBefore(int notBefore)`
    `void` | `setOfflineSessionIdleTimeout(int seconds)`
    `void` | `setOfflineSessionMaxLifespan(int seconds)`
    `void` | `setOfflineSessionMaxLifespanEnabled(boolean offlineSessionMaxLifespanEnabled)`
    `void` | `setOTPPolicy(OTPPolicy policy)`
    `void` | `setPasswordPolicy(PasswordPolicy policy)`
    `void` | `setPermanentLockout(boolean val)`
    `void` | `setQuickLoginCheckMilliSeconds(long val)`
    `void` | `setRefreshTokenMaxReuse(int revokeRefreshTokenCount)`
    `void` | `setRegistrationAllowed(boolean registrationAllowed)`
    `void` | `setRegistrationEmailAsUsername(boolean registrationEmailAsUsername)`
    `void` | `setRegistrationFlow(AuthenticationFlowModel flow)`
    `void` | `setRememberMe(boolean rememberMe)`
    `void` | `setResetCredentialsFlow(AuthenticationFlowModel flow)`
    `void` | `setResetPasswordAllowed(boolean resetPasswordAllowed)`
    `void` | `setRevokeRefreshToken(boolean revokeRefreshToken)`
    `void` | `setSmtpConfig(Map<String,String> smtpConfig)`
    `void` | `setSslRequired(SslRequired sslRequired)`
    `void` | `setSsoSessionIdleTimeout(int seconds)`
    `void` | `setSsoSessionIdleTimeoutRememberMe(int seconds)`
    `void` | `setSsoSessionMaxLifespan(int seconds)`
    `void` | `setSsoSessionMaxLifespanRememberMe(int seconds)`
    `void` | `setSupportedLocales(Set<String> locales)`
    `void` | `setUserManagedAccessAllowed(boolean userManagedAccessAllowed)`
    `void` | `setVerifyEmail(boolean verifyEmail)`
    `void` | `setWaitIncrementSeconds(int val)`
    `void` | `setWebAuthnPolicy(WebAuthnPolicy policy)` Set WebAuthn policy for 2-factor authentication
    `void` | `setWebAuthnPolicyPasswordless(WebAuthnPolicy policy)` Set WebAuthn passwordless policy below.
    `void` | `updateAuthenticationFlow(AuthenticationFlowModel model)`
    `void` | `updateAuthenticatorConfig(AuthenticatorConfigModel model)`
    `void` | `updateAuthenticatorExecution(AuthenticationExecutionModel model)`
    `void` | `updateComponent(ComponentModel component)`
    `void` | `updateIdentityProvider(IdentityProviderModel identityProvider)`
    `void` | `updateIdentityProviderMapper(IdentityProviderMapperModel mapping)`
    `void` | `updateRequiredActionProvider(RequiredActionProviderModel model)`
    `void` | `updateRequiredCredentials(Set<String> creds)`

    - ### Methods inherited from interface org.keycloak.models.RoleContainerModel

      `addDefaultRole, addRole, addRole, getDefaultRoles, getDefaultRolesStream, getRole, getRoles, getRoles, getRolesStream, getRolesStream, removeDefaultRoles, removeRole, searchForRoles, searchForRolesStream, updateDefaultRoles`

- - ### Method Detail

    - #### getId

          String getId()

      Specified by:
        `getId` in interface `RoleContainerModel`

    - #### getName

          String getName()

    - #### setName

          void setName(String name)

    - #### getDisplayName

          String getDisplayName()

    - #### setDisplayName

          void setDisplayName(String displayName)

    - #### getDisplayNameHtml

          String getDisplayNameHtml()

    - #### setDisplayNameHtml

          void setDisplayNameHtml(String displayNameHtml)

    - #### isEnabled

          boolean isEnabled()

    - #### setEnabled

          void setEnabled(boolean enabled)

    - #### getSslRequired

          SslRequired getSslRequired()

    - #### setSslRequired

          void setSslRequired(SslRequired sslRequired)

    - #### isRegistrationAllowed

          boolean isRegistrationAllowed()

    - #### setRegistrationAllowed

          void setRegistrationAllowed(boolean registrationAllowed)

    - #### isRegistrationEmailAsUsername

          boolean isRegistrationEmailAsUsername()

    - #### setRegistrationEmailAsUsername

          void setRegistrationEmailAsUsername(boolean registrationEmailAsUsername)

    - #### isRememberMe

          boolean isRememberMe()

    - #### setRememberMe

          void setRememberMe(boolean rememberMe)

    - #### isEditUsernameAllowed

          boolean isEditUsernameAllowed()

    - #### setEditUsernameAllowed

          void setEditUsernameAllowed(boolean editUsernameAllowed)

    - #### isUserManagedAccessAllowed

          boolean isUserManagedAccessAllowed()

    - #### setUserManagedAccessAllowed

          void setUserManagedAccessAllowed(boolean userManagedAccessAllowed)

    - #### setAttribute

          void setAttribute(String name,
                            String value)

    - #### setAttribute

          void setAttribute(String name,
                            Boolean value)

    - #### setAttribute

          void setAttribute(String name,
                            Integer value)

    - #### setAttribute

          void setAttribute(String name,
                            Long value)

    - #### removeAttribute

          void removeAttribute(String name)

    - #### getAttribute

          String getAttribute(String name)

    - #### getAttribute

          Integer getAttribute(String name,
                               Integer defaultValue)

    - #### getAttribute

          Long getAttribute(String name,
                            Long defaultValue)

    - #### getAttribute

          Boolean getAttribute(String name,
                               Boolean defaultValue)

    - #### getAttributes

          Map<String,String> getAttributes()

    - #### isBruteForceProtected

          boolean isBruteForceProtected()

    - #### setBruteForceProtected

          void setBruteForceProtected(boolean value)

    - #### isPermanentLockout

          boolean isPermanentLockout()

    - #### setPermanentLockout

          void setPermanentLockout(boolean val)

    - #### getMaxFailureWaitSeconds

          int getMaxFailureWaitSeconds()

    - #### setMaxFailureWaitSeconds

          void setMaxFailureWaitSeconds(int val)

    - #### getWaitIncrementSeconds

          int getWaitIncrementSeconds()

    - #### setWaitIncrementSeconds

          void setWaitIncrementSeconds(int val)

    - #### getMinimumQuickLoginWaitSeconds

          int getMinimumQuickLoginWaitSeconds()

    - #### setMinimumQuickLoginWaitSeconds

          void setMinimumQuickLoginWaitSeconds(int val)

    - #### getQuickLoginCheckMilliSeconds

          long getQuickLoginCheckMilliSeconds()

    - #### setQuickLoginCheckMilliSeconds

          void setQuickLoginCheckMilliSeconds(long val)

    - #### getMaxDeltaTimeSeconds

          int getMaxDeltaTimeSeconds()

    - #### setMaxDeltaTimeSeconds

          void setMaxDeltaTimeSeconds(int val)

    - #### getFailureFactor

          int getFailureFactor()

    - #### setFailureFactor

          void setFailureFactor(int failureFactor)

    - #### isVerifyEmail

          boolean isVerifyEmail()

    - #### setVerifyEmail

          void setVerifyEmail(boolean verifyEmail)

    - #### isLoginWithEmailAllowed

          boolean isLoginWithEmailAllowed()

    - #### setLoginWithEmailAllowed

          void setLoginWithEmailAllowed(boolean loginWithEmailAllowed)

    - #### isDuplicateEmailsAllowed

          boolean isDuplicateEmailsAllowed()

    - #### setDuplicateEmailsAllowed

          void setDuplicateEmailsAllowed(boolean duplicateEmailsAllowed)

    - #### isResetPasswordAllowed

          boolean isResetPasswordAllowed()

    - #### setResetPasswordAllowed

          void setResetPasswordAllowed(boolean resetPasswordAllowed)

    - #### getDefaultSignatureAlgorithm

          String getDefaultSignatureAlgorithm()

    - #### setDefaultSignatureAlgorithm

          void setDefaultSignatureAlgorithm(String defaultSignatureAlgorithm)

    - #### isRevokeRefreshToken

          boolean isRevokeRefreshToken()

    - #### setRevokeRefreshToken

          void setRevokeRefreshToken(boolean revokeRefreshToken)

    - #### getRefreshTokenMaxReuse

          int getRefreshTokenMaxReuse()

    - #### setRefreshTokenMaxReuse

          void setRefreshTokenMaxReuse(int revokeRefreshTokenCount)

    - #### getSsoSessionIdleTimeout

          int getSsoSessionIdleTimeout()

    - #### setSsoSessionIdleTimeout

          void setSsoSessionIdleTimeout(int seconds)

    - #### getSsoSessionMaxLifespan

          int getSsoSessionMaxLifespan()

    - #### setSsoSessionMaxLifespan

          void setSsoSessionMaxLifespan(int seconds)

    - #### getSsoSessionIdleTimeoutRememberMe

          int getSsoSessionIdleTimeoutRememberMe()

    - #### setSsoSessionIdleTimeoutRememberMe

          void setSsoSessionIdleTimeoutRememberMe(int seconds)

    - #### getSsoSessionMaxLifespanRememberMe

          int getSsoSessionMaxLifespanRememberMe()

    - #### setSsoSessionMaxLifespanRememberMe

          void setSsoSessionMaxLifespanRememberMe(int seconds)

    - #### getOfflineSessionIdleTimeout

          int getOfflineSessionIdleTimeout()

    - #### setOfflineSessionIdleTimeout

          void setOfflineSessionIdleTimeout(int seconds)

    - #### getAccessTokenLifespan

          int getAccessTokenLifespan()

    - #### isOfflineSessionMaxLifespanEnabled

          boolean isOfflineSessionMaxLifespanEnabled()

    - #### setOfflineSessionMaxLifespanEnabled

          void setOfflineSessionMaxLifespanEnabled(boolean offlineSessionMaxLifespanEnabled)

    - #### getOfflineSessionMaxLifespan

          int getOfflineSessionMaxLifespan()

    - #### setOfflineSessionMaxLifespan

          void setOfflineSessionMaxLifespan(int seconds)

    - #### getClientSessionIdleTimeout

          int getClientSessionIdleTimeout()

    - #### setClientSessionIdleTimeout

          void setClientSessionIdleTimeout(int seconds)

    - #### getClientSessionMaxLifespan

          int getClientSessionMaxLifespan()

    - #### setClientSessionMaxLifespan

          void setClientSessionMaxLifespan(int seconds)

    - #### getClientOfflineSessionIdleTimeout

          int getClientOfflineSessionIdleTimeout()

    - #### setClientOfflineSessionIdleTimeout

          void setClientOfflineSessionIdleTimeout(int seconds)

    - #### getClientOfflineSessionMaxLifespan

          int getClientOfflineSessionMaxLifespan()

    - #### setClientOfflineSessionMaxLifespan

          void setClientOfflineSessionMaxLifespan(int seconds)

    - #### setAccessTokenLifespan

          void setAccessTokenLifespan(int seconds)

    - #### getAccessTokenLifespanForImplicitFlow

          int getAccessTokenLifespanForImplicitFlow()

    - #### setAccessTokenLifespanForImplicitFlow

          void setAccessTokenLifespanForImplicitFlow(int seconds)

    - #### getAccessCodeLifespan

          int getAccessCodeLifespan()

    - #### setAccessCodeLifespan

          void setAccessCodeLifespan(int seconds)

    - #### getAccessCodeLifespanUserAction

          int getAccessCodeLifespanUserAction()

    - #### setAccessCodeLifespanUserAction

          void setAccessCodeLifespanUserAction(int seconds)

    - #### getUserActionTokenLifespans

          Map<String,Integer> getUserActionTokenLifespans()

      This method will return a map with all the lifespans available or an empty map, but never null.
      Returns:
        map with user action token lifespans

    - #### getAccessCodeLifespanLogin

          int getAccessCodeLifespanLogin()

    - #### setAccessCodeLifespanLogin

          void setAccessCodeLifespanLogin(int seconds)

    - #### getActionTokenGeneratedByAdminLifespan

          int getActionTokenGeneratedByAdminLifespan()

    - #### setActionTokenGeneratedByAdminLifespan

          void setActionTokenGeneratedByAdminLifespan(int seconds)

    - #### getActionTokenGeneratedByUserLifespan

          int getActionTokenGeneratedByUserLifespan()

    - #### setActionTokenGeneratedByUserLifespan

          void setActionTokenGeneratedByUserLifespan(int seconds)

    - #### getActionTokenGeneratedByUserLifespan

          int getActionTokenGeneratedByUserLifespan(String actionTokenType)

    - #### setActionTokenGeneratedByUserLifespan

          void setActionTokenGeneratedByUserLifespan(String actionTokenType,
                                                     Integer seconds)

    - #### getRequiredCredentials

          @Deprecated
          default List<RequiredCredentialModel> getRequiredCredentials()

      Deprecated. Use `getRequiredCredentialsStream` instead.

    - #### getRequiredCredentialsStream

          Stream<RequiredCredentialModel> getRequiredCredentialsStream()

    - #### addRequiredCredential

          void addRequiredCredential(String cred)

    - #### getPasswordPolicy

          PasswordPolicy getPasswordPolicy()

    - #### setPasswordPolicy

          void setPasswordPolicy(PasswordPolicy policy)

    - #### getOTPPolicy

          OTPPolicy getOTPPolicy()

    - #### setOTPPolicy

          void setOTPPolicy(OTPPolicy policy)

    - #### getWebAuthnPolicy

          WebAuthnPolicy getWebAuthnPolicy()

      Returns:
        WebAuthn policy for 2-factor authentication

    - #### setWebAuthnPolicy

          void setWebAuthnPolicy(WebAuthnPolicy policy)

      Set WebAuthn policy for 2-factor authentication
      Parameters:
        `policy` -

    - #### getWebAuthnPolicyPasswordless

          WebAuthnPolicy getWebAuthnPolicyPasswordless()

      Returns:
        WebAuthn passwordless policy below. This is temporary and will be removed later.

    - #### setWebAuthnPolicyPasswordless

          void setWebAuthnPolicyPasswordless(WebAuthnPolicy policy)

      Set WebAuthn passwordless policy below. This is temporary and will be removed later.
      Parameters:
        `policy` -

    - #### getRoleById

          RoleModel getRoleById(String id)

    - #### getDefaultGroups

          @Deprecated
          default List<GroupModel> getDefaultGroups()

      Deprecated.

    - #### getDefaultGroupsStream

          Stream<GroupModel> getDefaultGroupsStream()

    - #### addDefaultGroup

          void addDefaultGroup(GroupModel group)

    - #### removeDefaultGroup

          void removeDefaultGroup(GroupModel group)

    - #### getClients

          @Deprecated
          default List<ClientModel> getClients()

      Deprecated.

    - #### getClientsStream

          Stream<ClientModel> getClientsStream()

    - #### getClients

          @Deprecated
          default List<ClientModel> getClients(Integer firstResult,
                                                           Integer maxResults)

      Deprecated.

    - #### getClientsStream

          Stream<ClientModel> getClientsStream(Integer firstResult,
                                               Integer maxResults)

    - #### getClientsCount

          Long getClientsCount()

    - #### getAlwaysDisplayInConsoleClients

          @Deprecated
          default List<ClientModel> getAlwaysDisplayInConsoleClients()

      Deprecated.

    - #### getAlwaysDisplayInConsoleClientsStream

          Stream<ClientModel> getAlwaysDisplayInConsoleClientsStream()

    - #### addClient

          ClientModel addClient(String name)

    - #### addClient

          ClientModel addClient(String id,
                                String clientId)

    - #### removeClient

          boolean removeClient(String id)

    - #### getClientById

          ClientModel getClientById(String id)

    - #### getClientByClientId

          ClientModel getClientByClientId(String clientId)

    - #### searchClientByClientId

          @Deprecated
          default List<ClientModel> searchClientByClientId(String clientId,
                                                                       Integer firstResult,
                                                                       Integer maxResults)

      Deprecated.

    - #### searchClientByClientIdStream

          Stream<ClientModel> searchClientByClientIdStream(String clientId,
                                                           Integer firstResult,
                                                           Integer maxResults)

    - #### updateRequiredCredentials

          void updateRequiredCredentials(Set<String> creds)

    - #### getBrowserSecurityHeaders

          Map<String,String> getBrowserSecurityHeaders()

    - #### setBrowserSecurityHeaders

          void setBrowserSecurityHeaders(Map<String,String> headers)

    - #### getSmtpConfig

          Map<String,String> getSmtpConfig()

    - #### setSmtpConfig

          void setSmtpConfig(Map<String,String> smtpConfig)

    - #### getBrowserFlow

          AuthenticationFlowModel getBrowserFlow()

    - #### setBrowserFlow

          void setBrowserFlow(AuthenticationFlowModel flow)

    - #### getRegistrationFlow

          AuthenticationFlowModel getRegistrationFlow()

    - #### setRegistrationFlow

          void setRegistrationFlow(AuthenticationFlowModel flow)

    - #### getDirectGrantFlow

          AuthenticationFlowModel getDirectGrantFlow()

    - #### setDirectGrantFlow

          void setDirectGrantFlow(AuthenticationFlowModel flow)

    - #### getResetCredentialsFlow

          AuthenticationFlowModel getResetCredentialsFlow()

    - #### setResetCredentialsFlow

          void setResetCredentialsFlow(AuthenticationFlowModel flow)

    - #### getClientAuthenticationFlow

          AuthenticationFlowModel getClientAuthenticationFlow()

    - #### setClientAuthenticationFlow

          void setClientAuthenticationFlow(AuthenticationFlowModel flow)

    - #### getDockerAuthenticationFlow

          AuthenticationFlowModel getDockerAuthenticationFlow()

    - #### setDockerAuthenticationFlow

          void setDockerAuthenticationFlow(AuthenticationFlowModel flow)

    - #### getAuthenticationFlows

          @Deprecated
          default List<AuthenticationFlowModel> getAuthenticationFlows()

      Deprecated. Use `getAuthenticationFlowsStream` instead.

    - #### getAuthenticationFlowsStream

          Stream<AuthenticationFlowModel> getAuthenticationFlowsStream()

    - #### getFlowByAlias

          AuthenticationFlowModel getFlowByAlias(String alias)

    - #### addAuthenticationFlow

          AuthenticationFlowModel addAuthenticationFlow(AuthenticationFlowModel model)

    - #### getAuthenticationFlowById

          AuthenticationFlowModel getAuthenticationFlowById(String id)

    - #### removeAuthenticationFlow

          void removeAuthenticationFlow(AuthenticationFlowModel model)

    - #### updateAuthenticationFlow

          void updateAuthenticationFlow(AuthenticationFlowModel model)

    - #### getAuthenticationExecutions

          @Deprecated
          default List<AuthenticationExecutionModel> getAuthenticationExecutions(String flowId)

      Deprecated. Use `getAuthenticationExecutionsStream` instead.

    - #### getAuthenticationExecutionsStream

          Stream<AuthenticationExecutionModel> getAuthenticationExecutionsStream(String flowId)

      Returns sorted `AuthenticationExecutionModel` as a stream. It should be used with forEachOrdered if the ordering is required.
      Returns:
        Sorted stream

    - #### getAuthenticationExecutionById

          AuthenticationExecutionModel getAuthenticationExecutionById(String id)

    - #### getAuthenticationExecutionByFlowId

          AuthenticationExecutionModel getAuthenticationExecutionByFlowId(String flowId)

    - #### addAuthenticatorExecution

          AuthenticationExecutionModel addAuthenticatorExecution(AuthenticationExecutionModel model)

    - #### updateAuthenticatorExecution

          void updateAuthenticatorExecution(AuthenticationExecutionModel model)

    - #### removeAuthenticatorExecution

          void removeAuthenticatorExecution(AuthenticationExecutionModel model)

    - #### getAuthenticatorConfigs

          @Deprecated
          default List<AuthenticatorConfigModel> getAuthenticatorConfigs()

      Deprecated. Use `getAuthenticatorConfigsStream` instead.

    - #### getAuthenticatorConfigsStream

          Stream<AuthenticatorConfigModel> getAuthenticatorConfigsStream()

    - #### addAuthenticatorConfig

          AuthenticatorConfigModel addAuthenticatorConfig(AuthenticatorConfigModel model)

    - #### updateAuthenticatorConfig

          void updateAuthenticatorConfig(AuthenticatorConfigModel model)

    - #### removeAuthenticatorConfig

          void removeAuthenticatorConfig(AuthenticatorConfigModel model)

    - #### getAuthenticatorConfigById

          AuthenticatorConfigModel getAuthenticatorConfigById(String id)

    - #### getAuthenticatorConfigByAlias

          AuthenticatorConfigModel getAuthenticatorConfigByAlias(String alias)

    - #### getRequiredActionProviders

          @Deprecated
          default List<RequiredActionProviderModel> getRequiredActionProviders()

      Deprecated. Use `getRequiredActionProvidersStream` instead.

    - #### getRequiredActionProvidersStream

          Stream<RequiredActionProviderModel> getRequiredActionProvidersStream()

      Returns sorted `RequiredActionProviderModel` as a stream. It should be used with forEachOrdered if the ordering is required.
      Returns:
        Sorted stream

    - #### addRequiredActionProvider

          RequiredActionProviderModel addRequiredActionProvider(RequiredActionProviderModel model)

    - #### updateRequiredActionProvider

          void updateRequiredActionProvider(RequiredActionProviderModel model)

    - #### removeRequiredActionProvider

          void removeRequiredActionProvider(RequiredActionProviderModel model)

    - #### getRequiredActionProviderById

          RequiredActionProviderModel getRequiredActionProviderById(String id)

    - #### getRequiredActionProviderByAlias

          RequiredActionProviderModel getRequiredActionProviderByAlias(String alias)

    - #### getIdentityProviders

          @Deprecated
          default List<IdentityProviderModel> getIdentityProviders()

      Deprecated. Use `getIdentityProvidersStream` instead.

    - #### getIdentityProvidersStream

          Stream<IdentityProviderModel> getIdentityProvidersStream()

    - #### getIdentityProviderByAlias

          IdentityProviderModel getIdentityProviderByAlias(String alias)

    - #### addIdentityProvider

          void addIdentityProvider(IdentityProviderModel identityProvider)

    - #### removeIdentityProviderByAlias

          void removeIdentityProviderByAlias(String alias)

    - #### updateIdentityProvider

          void updateIdentityProvider(IdentityProviderModel identityProvider)

    - #### getIdentityProviderMappers

          @Deprecated
          default Set<IdentityProviderMapperModel> getIdentityProviderMappers()

      Deprecated. Use `getIdentityProviderMappersStream` instead.

    - #### getIdentityProviderMappersStream

          Stream<IdentityProviderMapperModel> getIdentityProviderMappersStream()

    - #### getIdentityProviderMappersByAlias

          @Deprecated
          default Set<IdentityProviderMapperModel> getIdentityProviderMappersByAlias(String brokerAlias)

      Deprecated. Use `getIdentityProviderMappersByAliasStream` instead.

    - #### getIdentityProviderMappersByAliasStream

          Stream<IdentityProviderMapperModel> getIdentityProviderMappersByAliasStream(String brokerAlias)

    - #### addIdentityProviderMapper

          IdentityProviderMapperModel addIdentityProviderMapper(IdentityProviderMapperModel model)

    - #### removeIdentityProviderMapper

          void removeIdentityProviderMapper(IdentityProviderMapperModel mapping)

    - #### updateIdentityProviderMapper

          void updateIdentityProviderMapper(IdentityProviderMapperModel mapping)

    - #### getIdentityProviderMapperById

          IdentityProviderMapperModel getIdentityProviderMapperById(String id)

    - #### getIdentityProviderMapperByName

          IdentityProviderMapperModel getIdentityProviderMapperByName(String brokerAlias,
                                                                      String name)

    - #### addComponentModel

          ComponentModel addComponentModel(ComponentModel model)

      Adds component model. Will call onCreate() method of ComponentFactory
      Parameters:
        `model` -
      Returns:

    - #### importComponentModel

          ComponentModel importComponentModel(ComponentModel model)

      Adds component model. Will NOT call onCreate() method of ComponentFactory
      Parameters:
        `model` -
      Returns:

    - #### updateComponent

          void updateComponent(ComponentModel component)

    - #### removeComponent

          void removeComponent(ComponentModel component)

    - #### removeComponents

          void removeComponents(String parentId)

    - #### getComponents

          @Deprecated
          default List<ComponentModel> getComponents(String parentId,
                                                                 String providerType)

      Deprecated. Use `getComponentsStream` instead.

    - #### getComponentsStream

          Stream<ComponentModel> getComponentsStream(String parentId,
                                                     String providerType)

      Returns stream of ComponentModels for specific parentId and providerType.
      Parameters:
        `parentId` - id of parent
        `providerType` - type of provider
      Returns:
        stream of ComponentModels

    - #### getComponentsStream

          Stream<ComponentModel> getComponentsStream(String parentId)

    - #### getComponents

          @Deprecated
          default List<ComponentModel> getComponents(String parentId)

      Deprecated. Use `getComponentsStream` instead.

    - #### getComponents

          @Deprecated
          default List<ComponentModel> getComponents()

      Deprecated. Use `getComponentsStream` instead.

    - #### getComponentsStream

          Stream<ComponentModel> getComponentsStream()

    - #### getComponent

          ComponentModel getComponent(String id)

    - #### getUserStorageProviders

          @Deprecated
          default List<UserStorageProviderModel> getUserStorageProviders()

      Deprecated. Use `getUserStorageProvidersStream` instead.

    - #### getUserStorageProvidersStream

          default Stream<UserStorageProviderModel> getUserStorageProvidersStream()

      Returns sorted `UserStorageProviderModel` as a stream. It should be used with forEachOrdered if the ordering is required.
      Returns:
        Sorted stream

    - #### getClientStorageProviders

          @Deprecated
          default List<ClientStorageProviderModel> getClientStorageProviders()

      Deprecated. Use `getClientStorageProvidersStream` instead.

    - #### getClientStorageProvidersStream

          default Stream<ClientStorageProviderModel> getClientStorageProvidersStream()

      Returns sorted `ClientStorageProviderModel` as a stream. It should be used with forEachOrdered if the ordering is required.
      Returns:
        Sorted stream

    - #### getRoleStorageProviders

          @Deprecated
          default List<RoleStorageProviderModel> getRoleStorageProviders()

      Deprecated. Use `getRoleStorageProvidersStream` instead.

    - #### getRoleStorageProvidersStream

          default Stream<RoleStorageProviderModel> getRoleStorageProvidersStream()

      Returns sorted `RoleStorageProviderModel` as a stream. It should be used with forEachOrdered if the ordering is required.
      Returns:
        Sorted stream

    - #### getStorageProviders

          default Stream<ComponentModel> getStorageProviders(Class<? extends Provider> storageProviderClass)

      Returns stream of ComponentModels that represent StorageProviders for class storageProviderClass in this realm
      Parameters:
        `storageProviderClass` - class
      Returns:
        stream of StorageProviders

    - #### getLoginTheme

          String getLoginTheme()

    - #### setLoginTheme

          void setLoginTheme(String name)

    - #### getAccountTheme

          String getAccountTheme()

    - #### setAccountTheme

          void setAccountTheme(String name)

    - #### getAdminTheme

          String getAdminTheme()

    - #### setAdminTheme

          void setAdminTheme(String name)

    - #### getEmailTheme

          String getEmailTheme()

    - #### setEmailTheme

          void setEmailTheme(String name)

    - #### getNotBefore

          int getNotBefore()

      Time in seconds since epoc
      Returns:

    - #### setNotBefore

          void setNotBefore(int notBefore)

    - #### isEventsEnabled

          boolean isEventsEnabled()

    - #### setEventsEnabled

          void setEventsEnabled(boolean enabled)

    - #### getEventsExpiration

          long getEventsExpiration()

    - #### setEventsExpiration

          void setEventsExpiration(long expiration)

    - #### getEventsListeners

          @Deprecated
          default Set<String> getEventsListeners()

      Deprecated. Use `getEventsListenersStream` instead.

    - #### getEventsListenersStream

          Stream<String> getEventsListenersStream()

    - #### setEventsListeners

          void setEventsListeners(Set<String> listeners)

    - #### getEnabledEventTypes

          @Deprecated
          default Set<String> getEnabledEventTypes()

      Deprecated. Use `getEnabledEventTypesStream` instead.

    - #### getEnabledEventTypesStream

          Stream<String> getEnabledEventTypesStream()

    - #### setEnabledEventTypes

          void setEnabledEventTypes(Set<String> enabledEventTypes)

    - #### isAdminEventsEnabled

          boolean isAdminEventsEnabled()

    - #### setAdminEventsEnabled

          void setAdminEventsEnabled(boolean enabled)

    - #### isAdminEventsDetailsEnabled

          boolean isAdminEventsDetailsEnabled()

    - #### setAdminEventsDetailsEnabled

          void setAdminEventsDetailsEnabled(boolean enabled)

    - #### getMasterAdminClient

          ClientModel getMasterAdminClient()

    - #### setMasterAdminClient

          void setMasterAdminClient(ClientModel client)

    - #### isIdentityFederationEnabled

          boolean isIdentityFederationEnabled()

    - #### isInternationalizationEnabled

          boolean isInternationalizationEnabled()

    - #### setInternationalizationEnabled

          void setInternationalizationEnabled(boolean enabled)

    - #### getSupportedLocales

          @Deprecated
          default Set<String> getSupportedLocales()

      Deprecated. Use `getSupportedLocalesStream` instead.

    - #### getSupportedLocalesStream

          Stream<String> getSupportedLocalesStream()

    - #### setSupportedLocales

          void setSupportedLocales(Set<String> locales)

    - #### getDefaultLocale

          String getDefaultLocale()

    - #### setDefaultLocale

          void setDefaultLocale(String locale)

    - #### createGroup

          default GroupModel createGroup(String name)

    - #### createGroup

          default GroupModel createGroup(String id,
                                         String name)

    - #### createGroup

          default GroupModel createGroup(String name,
                                         GroupModel toParent)

    - #### createGroup

          GroupModel createGroup(String id,
                                 String name,
                                 GroupModel toParent)

    - #### getGroupById

          GroupModel getGroupById(String id)

    - #### getGroups

          @Deprecated
          default List<GroupModel> getGroups()

      Deprecated. Use `getGroupsStream` instead.

    - #### getGroupsStream

          Stream<GroupModel> getGroupsStream()

    - #### getGroupsCount

          Long getGroupsCount(Boolean onlyTopGroups)

    - #### getGroupsCountByNameContaining

          Long getGroupsCountByNameContaining(String search)

    - #### getTopLevelGroups

          @Deprecated
          default List<GroupModel> getTopLevelGroups()

      Deprecated. Use `getTopLevelGroups` instead.

    - #### getTopLevelGroupsStream

          Stream<GroupModel> getTopLevelGroupsStream()

    - #### getTopLevelGroups

          @Deprecated
          default List<GroupModel> getTopLevelGroups(Integer first,
                                                                 Integer max)

      Deprecated. Use `getTopLevelGroupsStream` instead.

    - #### getTopLevelGroupsStream

          Stream<GroupModel> getTopLevelGroupsStream(Integer first,
                                                     Integer max)

    - #### searchForGroupByName

          @Deprecated
          default List<GroupModel> searchForGroupByName(String search,
                                                                    Integer first,
                                                                    Integer max)

      Deprecated. Use `searchForGroupByName` instead.

    - #### searchForGroupByNameStream

          Stream<GroupModel> searchForGroupByNameStream(String search,
                                                        Integer first,
                                                        Integer max)

    - #### removeGroup

          boolean removeGroup(GroupModel group)

    - #### moveGroup

          void moveGroup(GroupModel group,
                         GroupModel toParent)

    - #### getClientScopes

          @Deprecated
          default List<ClientScopeModel> getClientScopes()

      Deprecated. Use `getClientScopesStream` instead.

    - #### getClientScopesStream

          Stream<ClientScopeModel> getClientScopesStream()

    - #### addClientScope

          ClientScopeModel addClientScope(String name)

    - #### addClientScope

          ClientScopeModel addClientScope(String id,
                                          String name)

    - #### removeClientScope

          boolean removeClientScope(String id)

    - #### getClientScopeById

          ClientScopeModel getClientScopeById(String id)

    - #### addDefaultClientScope

          void addDefaultClientScope(ClientScopeModel clientScope,
                                     boolean defaultScope)

    - #### removeDefaultClientScope

          void removeDefaultClientScope(ClientScopeModel clientScope)

    - #### patchRealmLocalizationTexts

          void patchRealmLocalizationTexts(String locale,
                                           Map<String,String> localizationTexts)

      Patches the realm-specific localization texts. This method will not delete any text. It updates texts, which are already stored or create new ones if the key does not exist yet.

    - #### removeRealmLocalizationTexts

          boolean removeRealmLocalizationTexts(String locale)

    - #### getRealmLocalizationTexts

          Map<String,Map<String,String>> getRealmLocalizationTexts()

    - #### getRealmLocalizationTextsByLocale

          Map<String,String> getRealmLocalizationTextsByLocale(String locale)

    - #### getDefaultClientScopes

          @Deprecated
          default List<ClientScopeModel> getDefaultClientScopes(boolean defaultScope)

      Deprecated. Use `getDefaultClientScopesStream` instead.

    - #### getDefaultClientScopesStream

          Stream<ClientScopeModel> getDefaultClientScopesStream(boolean defaultScope)

Copyright © 2021 JBoss by Red Hat. All rights reserved.